# wxSharedPtr< T > Class Template Reference
[Smart Pointers]

`#include <wx/sharedptr.h>`

## Detailed Description

### template<typename T>
class wxSharedPtr< T >

A smart pointer with non-intrusive reference counting.

It is modeled after `boost::shared_ptr<>` and can be used with STL containers and wxVector<T> unlike `std::auto_ptr<>` and wxScopedPtr<T>.

##

Library: wxBase

Category: Smart Pointers

See also:
  wxScopedPtr<T>, wxWeakRef<T>, wxObjectDataPtr<T>

## Public Member Functions
wxEXPLICIT | wxSharedPtr (T *ptr=NULL)
| Constructor.
| wxSharedPtr (const wxSharedPtr< T > &tocopy)
| Copy constructor.
| ~wxSharedPtr ()
| Destructor.
T * | get () const
| Returns pointer to its object or NULL.
| operator unspecified_bool_type () const
| Conversion to a boolean expression (in a variant which is not convertible to anything but a boolean expression).
T | operator* () const
| Returns a reference to the object.
T * | operator-> () const
| Smart pointer member access.
wxSharedPtr< T > & | operator= (T *ptr)
| Assignment operator.
wxSharedPtr< T > & | operator= (const wxSharedPtr< T > &tocopy)
| Assignment operator.
void | reset (T *ptr=NULL)
| Reset pointer to ptr.
bool | unique () const
| Returns true if this is the only pointer pointing to its object.
long | use_count () const
| Returns the number of pointers pointing to its object.

List of all members.

## Constructor & Destructor Documentation

template<typename T >

wxEXPLICIT wxSharedPtr< T >::wxSharedPtr | ( | T * | ptr = `NULL` | ) |

Constructor.

Creates shared pointer from the raw pointer ptr and takes ownership of it.

template<typename T >

wxSharedPtr< T >::wxSharedPtr | ( | const wxSharedPtr< T > & | tocopy | ) |

Copy constructor.

template<typename T >

wxSharedPtr< T >::~wxSharedPtr | ( |  | ) |

Destructor.

## Member Function Documentation

template<typename T >

T* wxSharedPtr< T >::get | ( |  | ) | const

Returns pointer to its object or NULL.

template<typename T >

wxSharedPtr< T >::operator unspecified_bool_type | ( |  | ) | const

Conversion to a boolean expression (in a variant which is not convertible to anything but a boolean expression).

If this class contains a valid pointer it will return true, if it contains a NULL pointer it will return false.

template<typename T >

T wxSharedPtr< T >::operator* | ( |  | ) | const

Returns a reference to the object.

If the internal pointer is NULL this method will cause an assert in debug mode.

template<typename T >

T* wxSharedPtr< T >::operator-> | ( |  | ) | const

Smart pointer member access.

Returns pointer to its object.

If the internal pointer is NULL this method will cause an assert in debug mode.

template<typename T >

wxSharedPtr<T>& wxSharedPtr< T >::operator= | ( | const wxSharedPtr< T > & | tocopy | ) |

Assignment operator.

Releases any previously held pointer and creates a reference to the same object as topcopy.

template<typename T >

wxSharedPtr<T>& wxSharedPtr< T >::operator= | ( | T * | ptr | ) |

Assignment operator.

Releases any previously held pointer and creates a reference to ptr.

template<typename T >

void wxSharedPtr< T >::reset | ( | T * | ptr = `NULL` | ) |

Reset pointer to ptr.

If the reference count of the previously owned pointer was 1 it will be deleted.

template<typename T >

bool wxSharedPtr< T >::unique | ( |  | ) | const

Returns true if this is the only pointer pointing to its object.

template<typename T >

long wxSharedPtr< T >::use_count | ( |  | ) | const

Returns the number of pointers pointing to its object.

|  | [ top ]